VowelMap = {
    "halfu": {
        "Malayalam": "ഉ\u0D4D",
        "Devanagari": "ॶ",
        "Sharada": "𑆃𑇋𑆶",
        "Tamil": "உ\u0BCD",
        "IAST": "ŭ",
        "ISO": "ŭ",
        "IPA": "ʉ",
        "OthersRev": [4, "ʼ"],
        "OthersNonRev": [4],
    },
    "halfuu": {
        "Malayalam": "ഊ\u0D4D",
        "Devanagari": "ॷ",
        "Sharada": "𑆃𑇋𑆷",
        "Tamil": "ஊ\u0BCD",
        "IAST": "ŭ\u0304",
        "ISO": "ŭ\u0304",
        "IPA": "ʉː",
        "OthersRev": [5, "ʼ"],
        "OthersNonRev": [5],
    },
    "oe": {
        "Devanagari": "ॳ",
        "Sharada": "𑆃𑇋",
        "IAST": "ö",
        "ISO": "ö",
        "IPA": "ʉː",
        "OthersRev": [0, "ʼ"],
        "OthersNonRev": [0],
    },
    "oee": {
        "Devanagari": "ॴ",
        "Sharada": "𑆃𑇋𑆳",
        "IAST": "ȫ",
        "ISO": "ȫ",
        "IPA": "ʉː",
        "OthersRev": [0, "ʼʼ"],
        "OthersNonRev": [0],
    },
}

VowelSignMap = {
    "halfu": {
        "Malayalam": "\u0D41\u0D4D",
        "Devanagari": "\u0956",
        "Sharada": "\U000111CB\U000111B6",
        "Tamil": "\u0BC1\u0BCD",
        "IAST": "ŭ",
        "ISO": "ŭ",
        "IPA": "ʉː",
        "OthersRev": [3, "ʼ"],
        "OthersNonRev": [3],
    },
    "halfuu": {
        "Malayalam": "\u0D42\u0D4D",
        "Devanagari": "\u0957",
        "Sharada": "\U000111CB\U000111B7",
        "Tamil": "\u0BC2\u0BCD",
        "IAST": "ŭ\u0304",
        "ISO": "ŭ\u0304",
        "IPA": "ʉ",
        "OthersRev": [4, "ʼ"],
        "OthersNonRev": [4],
    },
    "oe": {
        "Devanagari": "\u093A",
        "Sharada": "\U000111CB",
        "IAST": "ö",
        "ISO": "ö",
        "IPA": "ʉː",
        "OthersRev": [-1, "ʼ\u02BD"],
        "OthersNonRev": [-1],
    },
    "oee": {
        "Devanagari": "\u093B",
        "Sharada": "\U000111CB\U000111B3",
        "IAST": "ȫ",
        "ISO": "ȫ",
        "IPA": "ʉː",
        "OthersRev": [-1, "ʼʼ"],
        "OthersNonRev": [-1],
    },
}

ConsonantMap = {}

SignMap = {}

AyogavahaMap = {
    "Jihvamuliya": {
        "IAST": "ẖ",
        "ISO": "ẖ",
        "IASTPali": "ẖ",
        "Titus": "ẖ",
        "HK": "X",
        "Itrans": "X",
        "Devanagari": "\u1CF5",
        "Bengali": "\u1CF5",
        "Assamese": "\u1CF5",
        "Kannada": "\u0CF1",
        "Tibetan": "\u0F88",
        "Brahmi": "\U00011003",
        "Sharada": "\U000111C2",
        "Newa": "\U00011460",
        "Soyombo": "\U00011A84",
        "OthersRev": [2, "\u02BD"],
        "OthersNonRev": [2],
    },
    "Upadhmaniya": {
        "IAST": "ḫ",
        "ISO": "ḫ",
        "IASTPali": "ḫ",
        "Titus": "ḫ",
        "HK": "F",
        "Itrans": "F",
        "Devanagari": "\u1CF6",
        "Bengali": "\u1CF6",
        "Assamese": "\u1CF6",
        "Kannada": "\u0CF2",
        "Tibetan": "\u0F89",
        "Brahmi": "\U00011004",
        "Sharada": "\U000111C3",
        "Newa": "\U00011461",
        "Soyombo": "\U00011A85",
        "OthersRev": [2, "\u02BD"],
        "OthersNonRev": [2],
    },
}
